      program specis

      implicit double precision (a-g,o-y),integer (h-n)

      parameter (nsp=10,l2=5,h5=7)

      character specie(nsp)*3, vname*8, yes*1

      integer  igo, ins(nsp), ifug, irk

      double precision 
     *       x(nsp,1000),f(1000),y(1000),ns,no,x3(1000),
     *       nh,nc,x1(1000),x2(1000),nco2, nh2o, nch4


      common / cst11 /fh2o,fco2/ cst5 /p,t,xo,u(6)
     *       / cstcoh /xs(nsp),g(nsp),v(nsp)/ cst26 /vol
     *       / cst10 /iff(2),idss(h5),ifug,ifyn,isyn
     *       / cst24 /ipot,jv(l2),iv(l2)
     *       / cst100 /dlnfo2,elag,gz,gy,gx,ibuf,hu,hv,hw,hx

      data tentoe, fo2, fs2, specie /2.302585093d0, 0.d0, 0d0,
     *      'H2O','CO2','CO ','CH4','H2 ','H2S','O2 ',
     *      'SO2','COS','UNK'/

c-----------------------------------------------------------------------

50    igo = 0
      fs2 = -9999.*tentoe/2.
      elag = 0.
c                                  initialize species fractions/volumes
      do 60 i = 1, nsp
60       xs(i) = 0.
c                                  get the users choice of EoS:   
      call rfluid (irk, ifug, 6)

      write (*,*) ' p, t, x0, x1, xonc?'
      read (*,*) p, t, xs0, xs1, xonc
      open (10,file='species.dat')

      write (10,*) '  1'
      write (10,*) '  0   0 '
      write (10,2020) p, t, xonc   
      write (10,*) ''
      write (10,*) ''
      write (10,*) ''
      write (10,*) '  2'
c                                  this is the max X(O), min X(O),
c                                  max log(Y), min log(Y) for
c                                  psvdraw
      write (10,*) '1. 0.0   0. -10. '
      write (10,*) ' 6 X(O)'
      write (10,*) ' 4log(Y) '

      xo = xs0
      igo = 0
      fmin = 20.
      fmax = -20.
      k = 0
c                                  for multispecies fluids set
c                                  up species indices:
      if (ifug.gt.6.and.ifug.lt.13) then
         vname = '  X(O)  '
         if (ifug.eq.7.or.ifug.eq.8) vname = 'log(fo2)'
         isp = 5
         do 1 i = 1, 6
1           ins(i) = i
         if (ifug.eq.12) then
            isp = 8
            ins(7) = 8
            ins(8) = 9
         end if
      else if (ifug.eq.16) then
         vname = '  X(O)  '
         isp = 3
         ins(1) = 1
         ins(2) = 5
         ins(3) = 7
      else if (ifug.eq.17) then
         vname = '  X(O)  '
         isp = 4
         ins(1) = 1
         ins(2) = 5
         ins(3) = 6
         ins(4) = 8
      else if (ifug.eq.13.or.ifug.eq.15) then 
         vname = ' X(H2)  '
      end if 
c                                  call fluid routine:
10    call cfluid (fo2, fs2)

      write (*,2000) xo,(xs(ins(i)),i=1,isp),fo2/tentoe

      k = k + 1

      ns = xs(6) + xs(8) + xs(9) + xs(10)
      no = xs(1) + xs(2)*2.+ xs(3) + xs(7)*2. 
     *               + xs(8)*2. + xs(9) + xs(10)*3.
      nc = xs(2) + xs(3) + xs(4) + xs(9)
      nh = (xs(1) + xs(5) + xs(6))*2. + xs(4)*4. 

      tot = ns + no + nh + nc     

      no = no / tot
      nc = nc / tot
      nh = nh / tot


      r0 = no

       nco2 = nc 
       nh2o = nh / 2
       no = no - 2.*nc - nh/2.

       tot = no + nco2 + nh2o

       yco2 = nco2 / tot
       yh2o = nh2o / tot
       yo = no / tot
  
       x1(k) = yco2 + 0.5 * yo
       x2(k) = -yo * 0.866025 
       write (*,2000) yh2o,yco2,yo,x1(k),x2(k)

       no = r0

       nh2o = no 
       nch4 = nc
       nh = nh - 4.*nc - 2.*no
       tot = nh + nch4 + nh2o
       ych4 = nch4 / tot
       yh2o = nh2o / tot
       yh = nh / tot  
       x3(k) = yh2o + 0.5 * yh
       y(k) = -yh * 0.866025 
       write (*,2000) yh2o,ych4,yh,x3(k),y(k)


      xo = xo + xonc

      goto (20), igo
      if (xo.gt.xs1) then
         xo = xs1
         igo = 1
      end if 

      goto 10

c         
20       write (10,2010) 2*k,1,1,1,1,1,'sat co2-h2o-o' 
         write (10,2020) (x1(l), x2(l) ,l=1,k)

         write (10,2010) 2*k,1,1,1,1,1,'sat ch4-xh2o-h' 
         write (10,2020) (x3(l) , y(l), l=1,k)
   
2000  format (8(g12.6,2x))
2010  format (i5,5(i2,1x),a8)
2020  format (6(g12.6,1x))
1210  format (/,' Change EoS, buffer, or graphite activity (y/n)?',/)
1220  format (a1)

99    write (*,1210) 
      read (*,1220) yes
      if (yes.eq.'y'.or.yes.eq.'Y') goto 50

      write (10,*) ' 1   1   1   1   1 1.0'
      write (10,*) ' 0   0  '

      end 
 
      block data
c-----------------------------------------------------------------------
      implicit double precision (a-g,o-y)
 
      common/ cst5 /p,t,xco2,u1,u2,tr,pr,r,ps/ cst85 /pp,tt,yy,rr
      data r,rr/8.3144126d0,83.14d0/
      end
