
      PROGRAM WERAMI
 
      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      real xy(2),xyp(2,2),prp(l5),dxy(2), coef(0:10)
 
      character*100 n4name,fname, vname*8, yes*1
 
      parameter (l3=l2+2)

      common/ vs    /vmin(l3),vmax(l3),iv/ vsa /vname(l3)
      common/ basic /n4,ifont,icopt,jwidth,iop0
     *      / cst84 /rcps(k7),icps(k7),icx,jcx,lop

 
      n4 = 24
c                                 get plot file name
      write (*,1250) 
      read (*,1050) fname
c                                 read header info from 
c                                 plot file
      open (n4,err=91,file=fname,status='old')
      call plinp (tmin,tmax,pmin,pmax)
      close (n4)
c                                 read assemblage data
c                                 from b-plot file 
	call bplinp (fname,kpoly)
c                                 read polygons from p-plot file:
      if (icopt.eq.6) call pplinp (fname)

20    write (*,1020) 
      read (*,*,err=20) imode

      if (imode.eq.1) then 

         n4name = fname 
         call inblnk (n4name,'r')
         write (*,1030) n4name
         open (n4,file=n4name) 

10       write (*,1000) (vname(i), i = 1, 2)
         read (*,*) x, y

         if (x+y.eq.0e0) goto 99

         xy(1) = x
         xy(2) = y

         do i = 1, 2
            if (xy(i).lt.vmin(i).or.xy(i).gt.vmax(i)) then  
                write (*,1010) vname(i),vmin(i),vmax(i)
                goto 10 
            end if 
         end do 
 
         call amiin (x,y,iam)
         if (iam.ne.0) then 
            call calpr1 (x,y,iam,6)
            call calpr1 (x,y,iam,n4)
         else 
            write (*,1070)
         end if 
         
         goto 10 

      else if (imode.eq.2) then 

         call chsprp (lop,icx,jcx,icps,rcps)

         write(*,1040)
         read (*,1050) yes 
         if (yes.eq.'y'.or.yes.eq.'Y') then 
	      do i = 1, 2
30             write (*,1060) vname(i),vmin(i),vmax(i)
               read (*,*,err=30) vmin(i),vmax(i)
            end do 
         end if 

         write (*,1080) 
         read (*,*) nx,ny
         
         do i = 1, 2
            vmin(i) = vmin(i) + (vmax(i)-vmin(i))*1e-6
            vmax(i) = vmax(i) - (vmax(i)-vmin(i))*1e-6
         end do 

         dx = (vmax(1)-vmin(1))/float(nx-1)
         dy = (vmax(2)-vmin(2))/float(ny-1)


         n4name = fname 
         call inblnk (n4name,'c')
         write (*,1110) n4name
         open (n4,file=n4name) 

         write (n4,1050) fname
         write (n4,*) nx,ny,vmin(1),vmin(2),dx,dy
         write (n4,1100) (vname(i),i=1,2)
         do j = 1, ny 
            y = vmin(2)+dy*float(j-1)
            do i = 1, nx 
               call polprp (prp(i),vmin(1)+dx*float(i-1),y)
            end do 
            write (n4,1120) (prp(i), i = 1, nx)
         end do 
      else if (imode.eq.3) then 

         call chsprp (lop,icx,jcx,icps,rcps)

         n4name = fname 
         call inblnk (n4name,'c')
         write (*,1130) n4name
         open (n4,file=n4name) 

45       do i = 1, 2
40          write (*,1140) i,vname(1),vname(2)
            read (*,*,err=40) xyp(1,i),xyp(2,i)
            do j = 1, 2
               if (xyp(j,i).lt.vmin(j).or.xyp(j,i).gt.vmax(j)) then  
                   write (*,1010) vname(j),vmin(j),vmax(j)
                   goto 40
                end if 
            end do 
         end do 

         do j = 1, 2
            dxy(j) = xyp(j,2) - xyp(j,1)
            if (dxy(j).eq.0d0) idxy = j
         end do 

         if (dxy(1).eq.0d0.and.dxy(2).eq.0d0) then
            write (*,*) 
     *            'initial and final coordinates cannot be identical'
            goto 45
         end if   

         write (*,1150) 
         read (*,*) ipts

         if (idxy.eq.0) then 
            write (*,1160) (i,vname(i),i= 1, 2)
            read (*,*) ivi
            ivd = 2
            if (ivi.eq.2) ivd = 1 

            s = dxy(ivd)/dxy(ivi)
         else 
            ivi = 1
            ivd = idxy 
            if (idxy.eq.1) ivi = 2
            s = 0d0 
         end if 

         d = dxy(ivi)/float(ipts - 1)

         icurve = 0

         if (idxy.eq.0) then 
            write (*,1200) 
            read (*,1050) yes 
            if (yes.eq.'y'.or.yes.eq.'Y') then 
               icurve = 1
               write (*,1210) vname(ivd),vname(ivi)
               read (*,*) iord
               do i = 0, iord
                  write (*,1220) i
                  read (*,*) coef(i)
               end do
            end if        
         end if 

         write (*,1180) vname(ivi),vname(ivd)

         nprop = 0

80       do i = 1, ipts
            xy(ivi) = xyp(ivi,1) + float(i-1)*d
            if (icurve.eq.0) then 
               xy(ivd) = xyp(ivd,1) + s*(xy(ivi)-xyp(ivi,1))
            else 
               xy(ivd) = 0d0
               do j = 0, iord
                  xy(ivd) = xy(ivd) + coef(j)*xy(ivi)**(j)
               end do
            end if 

            call polprp(p,xy(1),xy(2))
            write (n4,1170) nprop,xy(ivi),p,xy(ivd)
            write (*,1190) xy(ivi),xy(ivd),p
         end do 

         write (*,1230)
         read (*,1050) yes
         nprop = nprop + 1
         if (yes.eq.'y'.or.yes.eq.'Y') then 
            call chsprp (lop,icx,jcx,icps,rcps)
            goto 80
         end if 

      else if (imode.eq.4) then 

         nprop = 0

         call chsprp (lop,icx,jcx,icps,rcps)

         n4name = fname 
         call inblnk (n4name,'c')
         write (*,1130) n4name
         open (n4,file=n4name) 

         open (33,file='geotherm.dat',err=120)
         read (33,*) pmin,pmax,ixy
110      read (33,*,end=99) tmin1,tmax1,dt1,a1,b1,c1,d1

         if (dt1.lt.0d0) then 
            x0 = tmax1
            x1 = tmin1
         else 
            x0 = tmin1
            x1 = tmax1
         end if 

90       x = x0

         do i = 1, 1000
            y = a1 + b1*x + c1*x**2 + d1*x**3
            if (y.le.pmax.and.y.ge.pmin) then 
               if ((dt1.gt.0d0.and.x.le.x1).or.
     *             (dt1.lt.0d0.and.x.ge.x1)) then
                  if (ixy.eq.0) then 
                     call polprp(p,x,y)
                  else
                     call polprp(p,y,x)
                  end if 
                  write (n4,1170) nprop,x,p,y
                  write (*,1190) x,y,p
               else 
                  goto 100
               end if 
            end if 
            x = x + dt1
         end do  

100      write (*,1230)
         read (*,1050) yes
         nprop = nprop + 1
         if (yes.eq.'y'.or.yes.eq.'Y') then 
            call chsprp (lop,icx,jcx,icps,rcps)
            goto 90
         end if 
         goto 110
120      write (*,*) 'Missing file geotherm.dat '
         goto 99

      else 
  
         goto 20 

      end if 

      goto 99

91    write (*,1240) fname
      stop

1000  format (/,'Enter ',a,' and ',a,' (zeroes to quit):')
1010  format (/,'The plot file range for ',a,' is ',g12.4,' - ',g12.4,
     *        /,'Try again:',/)
1020  format (/,'Select operational mode:',/,
     *        4x,'1 - compute properties at specified conditions',/,
     *        4x,'2 - create a property grid (plot with pscontor)',/,
     *        4x,'3 - compute properties along a curve or line',
     *        ' (plot with pspts)',/,
     *        4x,'4 - as in 3, but input from file',/)
1030  format (/,'Console output will be echoed in file:',/,a,/)
1040  format (/,'Change default variable range (y/n)?')
1050  format (a)
1060  format (/,'Current limits on ',a,' are: ',g12.6,'->',g12.6,/,
     *        'Enter new values:')
1070  format (/,'No polygon bounds the specified conditions.',/,
     *        'Data missing, or you have specified conditions on an',
     *        ' edge of a polygon.',/)
1080  format (/,'Enter number of nodes in and x and y directions:')
1100  format (2a8)
1110  format (/,'Writing grid data to file:',/,a,/)
1120  format (10(g12.6,1x))
1130  format (/,' Writing profile to file:',/,a,/)
1140  format (/,'Enter endpoint ',i1,' (',a,'-',a,') coordinates:')
1150  format (/,'How many points along the profile?')
1160  format (/,'Select independent variable: ',2(/,1x,i1,' - ',a))
1170  format (1x,i1,3(1x,g12.6))
1180  format (/,3x,a8,5x,a8,2x,'  Property   ')
1190  format (3(1x,g12.6))
1200  format (/,'Construct a non-linear profile (y/n)?')
1210  format (/,'Profile must be described by the function',/,a,
     *        ' = Sum ( c(i) * ',a,' ^i, i = 0..n)',/,'Enter n (<10)')
1220  format (/,'Enter c(',i2,')')
1230  format (/,'Evaluate additional properties (y/n)?',/)
1240  format (/,'No such file as: ',a,/)
1250  format (/,'Enter the VERTEX plot file name:')

99    end
